/*  unixtime.c -- MiNTLib.
    Copyright (C) 1999 Guido Flohr <gufl0000@stud.uni-sb.de>

    This file is part of the MiNTLib project, and may only be used
    modified and distributed under the terms of the MiNTLib project
    license, COPYMINT.  By continuing to use, modify, or distribute
    this file you indicate that you have read the license and
    understand and accept it fully.
*/

#include <time.h>

/* Convert a GEMDOS time to seconds since the epoch.
   The calculated value is always in local time.  */
static int const
mth_start[13] = { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365 };

time_t __unixtime (unsigned timestamp, unsigned datestamp)
{
  register int sec, min, hour;
  register int mday, mon, year;
  register long s;
  
  sec = (timestamp & 31) << 1;
  min = (timestamp >> 5) & 63;
  hour  = (timestamp >> 11) & 31;
  
  mday  = datestamp & 31;
  mon = ((datestamp >> 5) & 15) - 1;
  year  = 80 + ((datestamp >> 9) & 127);
  
  /* calculate tm_yday here */
  s = (mday - 1) + mth_start[mon] + /* Leap year correction.  */
    (((year % 4) != 0 ) ? 0 : (mon > 1));
  
  s = (sec) + (min * 60L) + (hour * 3600L) +
    (s * 86400L) + ((year - 70) * 31536000L) +
    ((year - 69) / 4) * 86400L;
  
  return s;
}
